package com.ccwangluo.im.ui.login;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ProgressBar;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.ccwangluo.im.data.LoginViewModel;
import com.ccwangluo.im.databinding.FragmentLoginBinding;

/**
 */
public class LoginFragment extends Fragment {

    private FragmentLoginBinding binding;
    private LoginViewModel loginViewModel;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentLoginBinding.inflate(inflater, container, false);
        loginViewModel = new ViewModelProvider(this)
                .get(LoginViewModel.class);

        final EditText usernameEditText = binding.username;
        final EditText UserIdEditText = binding.password;
        final Button loginButton = binding.login;
        final ProgressBar loadingProgressBar = binding.loading;

        loginViewModel.loginState.observe(getViewLifecycleOwner(), new Observer<Boolean>() {
            @Override
            public void onChanged(Boolean aBoolean) {
                loadingProgressBar.setVisibility(View.GONE);
                if (aBoolean){

                }
            }
        });


        loginButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                loadingProgressBar.setVisibility(View.VISIBLE);
                String username = usernameEditText.getText().toString();
                if (TextUtils.isEmpty(username)){
                    Toast.makeText(getContext(),"username is empty",Toast.LENGTH_SHORT).show();
                    return;
                }
                String id = UserIdEditText.getText().toString();
                if (TextUtils.isEmpty(id)){
                    Toast.makeText(getContext(),"userid is empty",Toast.LENGTH_SHORT).show();
                    return;
                }
                loginViewModel.login(username,id);
            }
        });

        return binding.getRoot();
    }
}