package com.ccwangluo.im.ui.notifications;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.fragment.app.Fragment;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.ccwangluo.ccim.CCIMClient;
import com.ccwangluo.ccim.data.PushChannelMsgRes;
import com.ccwangluo.ccim.listener.ResultCallback;
import com.ccwangluo.im.adapter.ChannelMsgAdapter;
import com.ccwangluo.im.data.LoginViewModel;
import com.ccwangluo.im.databinding.FragmentChannelConnectBinding;

import java.util.ArrayList;
import java.util.List;

public class ConnectChannelFragment extends Fragment {
    private FragmentChannelConnectBinding binding;
    private LoginViewModel loginViewModel;
    private ChannelMsgAdapter channelMsgAdapter;
    private List<PushChannelMsgRes.MessageDTO> list = new ArrayList<>();

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentChannelConnectBinding.inflate(inflater, container, false);
        loginViewModel = new ViewModelProvider(getActivity())
                .get(LoginViewModel.class);

        channelMsgAdapter = new ChannelMsgAdapter(list,getContext());

        binding.msgList.setAdapter(channelMsgAdapter);

        long channelId = getArguments().getLong("channelId");

        loginViewModel.channelMsgList.observe(getViewLifecycleOwner(), new Observer<List<PushChannelMsgRes>>() {
            @Override
            public void onChanged(List<PushChannelMsgRes> pushChannelMsgRes) {
                list.clear();
                for (PushChannelMsgRes pushChannelMsgRe : pushChannelMsgRes) {
                    if (pushChannelMsgRe.getChannelId() == channelId) {
                        list.add(pushChannelMsgRe.getMessage());
                    }
                }
                channelMsgAdapter.refreshData();
                binding.msgList.setSelection(channelMsgAdapter.getCount() - 1);
            }
        });

        binding.sendBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String content = binding.sendEdit.getText().toString();
                CCIMClient.getInstance().sendChannelMessage(content, channelId, new ResultCallback() {
                    @Override
                    public void onSuccess() {
                        binding.sendEdit.setText("");
                        PushChannelMsgRes.MessageDTO messageDTO = new PushChannelMsgRes.MessageDTO();
                        messageDTO.setContent(content);
                        PushChannelMsgRes pushChannelMsgRes = new PushChannelMsgRes();
                        pushChannelMsgRes.setMessage(messageDTO);
                        pushChannelMsgRes.setChannelId(channelId);
                        loginViewModel.addChannelMsg(pushChannelMsgRes);
                        Toast.makeText(getContext(),"send Success",Toast.LENGTH_LONG).show();
                    }
                });
            }
        });


        return binding.getRoot();
    }
}